namespace Encompass
{
    internal class ComponentMessageEmitter<TComponent> : Engine where TComponent : struct, IComponent
    {
        public ComponentMessageEmitter() : base()
        {
            sendTypes.Add(typeof(ComponentMessage<TComponent>));
        }

        public override void Update(double dt)
        {
            foreach (var (component, entity) in InternalRead<TComponent>())
            {
                ComponentMessage<TComponent> componentMessage;
                componentMessage.entity = entity;
                componentMessage.component = component;
                SendMessage(componentMessage);
                SendExistingComponentMessage(componentMessage);
            }
        }
    }
}
